/** Header file generated with fdesign on Sun Dec 30 18:02:48 2007.**/

#ifndef FD_caustics_h_
#define FD_caustics_h_

/** Callbacks, globals and object handlers **/
extern void cc_dx(FL_OBJECT *, long);
extern void cc_tol(FL_OBJECT *, long);
extern void caustic_done(FL_OBJECT *, long);
extern void critic_curve(FL_OBJECT *, long);
extern void caustic_curve(FL_OBJECT *, long);
extern void c_set_input(FL_OBJECT *, long);


/**** Forms and Objects ****/
typedef struct {
	FL_FORM *caustics;
	void *vdata;
	char *cdata;
	long  ldata;
	FL_OBJECT *c_dx;
	FL_OBJECT *c_tol;
	FL_OBJECT *done_c;
	FL_OBJECT *critic_c;
	FL_OBJECT *caustic_c;
	FL_OBJECT *c_set;
} FD_caustics;

extern FD_caustics * create_form_caustics(void);

#endif /* FD_caustics_h_ */
