/* Form definition file generated with fdesign. */

/* #include <X11/forms.h> */

#include <stdlib.h>
#include <forms.h>
#include "glform.h"
#include "glxf.h"

// static int wy = 390;

static FL_PUP_ENTRY fdchoice_0[] =
{ 
  /*  itemtext              callback  shortcut   mode */

  {"Source Menu",	       0,	"",	 FL_PUP_NONE},
  {"Filled Circle",            0,	"",	 FL_PUP_NONE},
  {"Colour. Rings",	       0,	"",	 FL_PUP_NONE},
  {"Image File",	       0,	"",	 FL_PUP_NONE},
  {0}
};

static FL_PUP_ENTRY fdchoice_1[] =
{ 
  /*  itemtext                 callback  shortcut  mode */

  {"Model Menu",                    0,     "",     FL_PUP_NONE},  
  {"Chang-Refs.", 	            0,     "",     FL_PUP_NONE},  
  {"SIS",                           0,	   "",     FL_PUP_NONE},  
  {"NIS",                           0,	   "",	   FL_PUP_NONE}, 
  {"Trans. Sphere",	            0,	   "",	   FL_PUP_NONE}, 
  {"Elliptic Model",	            0,	   "",	   FL_PUP_NONE}, 
  {"King Model",	            0,	   "",	   FL_PUP_NONE}, 
  {"Trunc. King",   	            0,	   "",     FL_PUP_NONE},
  {"Hubble Model",	            0,     "",     FL_PUP_NONE},
  {"De Vaucouleur",	            0,     "",     FL_PUP_NONE},
  {"Spiral Model",	            0,     "",     FL_PUP_NONE},
  {"Multipole M.",	            0,     "",	   FL_PUP_NONE},
  {"Rotation Lens",	            0,     "",	   FL_PUP_NONE},
  {"Double P. M.",                  0,     "",	   FL_PUP_NONE},
  {"Uniform Ring",	            0,     "",     FL_PUP_NONE},
  {"Second Order",	            0,     "",     FL_PUP_NONE},
  {"Elliptic SIS",	            0,	   "",	   FL_PUP_NONE}, 
  {"Elliptic King",	            0,	   "",     FL_PUP_NONE}, 
  {"Elliptic Hubble",	            0,     "",	   FL_PUP_NONE}, 
  {"Elliptic NIS",	            0,     "",     FL_PUP_NONE},
  {"Ellip. Plummer",	            0,     "",     FL_PUP_NONE},
  {"Kassiola-Kov.",	            0,     "",     FL_PUP_NONE},
  {"NFW",	                    0,     "",     FL_PUP_NONE},  
  {"Barkana",	                    0,     "",     FL_PUP_NONE},  
  {0}
};

/*

static FL_PUP_ENTRY fdchoice_2[] =
{ 

**/

  /*  itemtext              callback  shortcut   mode */

/*
  
  {"Caustic / CC",	       0,	"",	 FL_PUP_NONE},
  {"Caustic",                  0,	"",	 FL_PUP_NONE},
  {"Critical Curve",	       0,	"",	 FL_PUP_NONE},
  {0}
};

**/

static FL_PUP_ENTRY fdmenu_Save_2[] =
{ 
  /*  itemtext      callback  shortcut   mode */
  
  {"xview",	        0,	"",	 FL_PUP_RADIO},
  {"display",	        0,	"",	 FL_PUP_RADIO},
  {"gimp",	        0,	"",	 FL_PUP_RADIO},
  {"snapshot",	        0,	"",	 FL_PUP_RADIO},
  {0}
};

static FL_PUP_ENTRY fdmenu_Save_3[] =
{ 
  /*  itemtext              callback  shortcut   mode */

  {"Evolution",                0,	"",	 FL_PUP_NONE},
  {"Simplex",	               0,	"",	 FL_PUP_NONE},
  {0}
};

static FL_PUP_ENTRY fdmenu_caustic[] =
{ 
  /*  itemtext      callback  shortcut   mode */
  
  {"critical curve",  0,	"",	 FL_PUP_RADIO},
  {"caustic",	      0,	"",	 FL_PUP_RADIO},
  {"both curves",     0,	"",	 FL_PUP_RADIO},
  {0}
};

// #include "crossbut.c"

FD_GLcp *create_form_GLcp(void)
{
  FL_OBJECT *obj;
  FD_GLcp *fdui = (FD_GLcp *) fl_calloc(1, sizeof(*fdui));

  /*
    
  fdui->GLcp = fl_bgn_form(FL_NO_BOX, 880, 700);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 880, 700, "");
  fl_set_object_resize(obj, FL_RESIZE_ALL);

  **/

  fdui->GLcp = fl_bgn_form(FL_NO_BOX, 880, 570);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 880, 570, "");
  fl_set_object_resize(obj, FL_RESIZE_ALL);

  obj = fl_add_text(FL_NORMAL_TEXT, 20, 20, 840, 70, "GL Control Panel");
  fl_set_object_boxtype(obj, FL_UP_BOX);      

  // fl_set_object_lsize(obj, FL_LARGE_SIZE);

  fl_set_object_lsize(obj, FL_HUGE_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_EMBOSSED_STYLE);

  fdui->source_pos = obj = 
    fl_add_positioner(FL_NORMAL_POSITIONER, 20, 120, 170, 170,
                      "Source Position");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_DODGERBLUE, FL_RED); 
  fl_set_object_lcolor(obj, FL_RIGHT_BCOL);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_TOP);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_source_pos, (long)(fdui));
  fl_set_positioner_xbounds(obj, -4.0, 4.0);
  fl_set_positioner_ybounds(obj, -4.0, 4.0);
  fl_set_positioner_xvalue(obj, 0.0);
  fl_set_positioner_yvalue(obj, 0.0);
  fl_set_positioner_xstep(obj, 0.01);
  fl_set_positioner_ystep(obj, 0.01);

  /*
    
  fdui->x_pos = obj =
    fl_add_counter(FL_NORMAL_COUNTER, 410, 130, 120, 30, "X ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1, FL_MCOL);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_counter_precision(obj, 2);
  fl_set_counter_bounds(obj, -4.00, 4.00);
  fl_set_counter_step(obj, 0.01, 0.10);
  fl_set_object_callback(obj, cb_source_pos, (long)(fdui));

  fdui->y_pos = obj =
    fl_add_counter(FL_NORMAL_COUNTER, 410, 170, 120, 30, "Y ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1, FL_MCOL);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_counter_precision(obj, 2);
  fl_set_counter_bounds(obj, -4.00, 4.00);
  fl_set_counter_step(obj, 0.01, 0.10);
  fl_set_object_callback(obj, cb_source_pos, (long)(fdui));

  fdui->presicion = obj = 
    fl_add_counter(FL_SIMPLE_COUNTER, 410, 210, 120, 30, "N ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1,FL_MCOL);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_object_callback(obj, cb_presicion, 0);
  fl_set_counter_precision(obj, 0);
  fl_set_counter_bounds(obj, 1, 10);
  fl_set_counter_value(obj, 4);
  fl_set_counter_step(obj, 1, 1);

  fdui->choice0 = obj = fl_add_choice(FL_NORMAL_CHOICE, 20, 370, 170, 40,"");
  fl_set_object_boxtype(obj, FL_UP_BOX);      
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER);
  fl_set_object_callback(obj, cb_source, (long)(fdui));
  fl_set_choice_entries(obj, fdchoice_0);
  fl_set_choice(obj, 1);

  fdui->choice1 = obj = fl_add_choice(FL_NORMAL_CHOICE, 20, 320, 170, 40, "");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_TINY_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_model, (long)(fdui));
  fl_set_choice_entries(obj, fdchoice_1);
  fl_set_choice(obj, 1);
  
  **/

  fdui->x_pos = obj =
    fl_add_counter(FL_NORMAL_COUNTER, 220, 130, 100, 35, "X ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1, FL_PALEGREEN);

  // fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_counter_precision(obj, 2);
  fl_set_counter_bounds(obj, -4.00, 4.00);
  fl_set_counter_step(obj, 0.01, 0.10);
  fl_set_object_callback(obj, cb_source_pos, (long)(fdui));

  fdui->y_pos = obj =
    fl_add_counter(FL_NORMAL_COUNTER, 220, 170, 100, 35, "Y ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1, FL_PALEGREEN);
  
  // fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_counter_precision(obj, 2);
  fl_set_counter_bounds(obj, -4.00, 4.00);
  fl_set_counter_step(obj, 0.01, 0.10);
  fl_set_object_callback(obj, cb_source_pos, (long)(fdui));

  fdui->presicion = obj = 
    fl_add_counter(FL_SIMPLE_COUNTER, 220, 210, 100, 35, "N ");
  fl_set_object_boxtype(obj, FL_DOWN_BOX);
  fl_set_object_color(obj, FL_COL1, FL_PALEGREEN);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_LEFT);
  fl_set_object_callback(obj, cb_presicion, 0);
  fl_set_counter_precision(obj, 0);
  fl_set_counter_bounds(obj, 1, 10);
  fl_set_counter_value(obj, 4);
  fl_set_counter_step(obj, 1, 1);

  fdui->im_win = obj = 
    fl_add_button(FL_PUSH_BUTTON, 210, 250, 120, 35, "Image Window");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, image_win, (long)(fdui));
      
  fdui->choice0 = obj = 
    fl_add_choice(FL_NORMAL_CHOICE, 340, 110, 100, 35, "");
  fl_set_object_boxtype(obj, FL_UP_BOX);      
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER);
  fl_set_object_callback(obj, cb_source, (long)(fdui));

  // fl_set_choice_entries(obj, fdchoice_0);

  fl_addto_choice(obj, "Filled Circle");
  fl_addto_choice(obj, "Colour. Rings");
  fl_addto_choice(obj, "Image File");
  fl_set_choice(obj, 1);

  fdui->choice1 = obj = fl_add_choice(FL_NORMAL_CHOICE, 340, 150, 100, 35, "");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_model, (long)(fdui));

  // fl_set_choice_entries(obj, fdchoice_1);

  fl_addto_choice(obj, "Chang-Refsdal");
  fl_addto_choice(obj, "SIS");
  fl_addto_choice(obj, "NIS");
  fl_addto_choice(obj, "Transparent Sphere");
  fl_addto_choice(obj, "Elliptic Model");
  fl_addto_choice(obj, "King Model");
  fl_addto_choice(obj, "Truncated King");
  fl_addto_choice(obj, "Hubble Model");
  fl_addto_choice(obj, "De Vaucouleur");
  fl_addto_choice(obj, "Spiral Model");
  fl_addto_choice(obj, "Multipole Model");
  fl_addto_choice(obj, "Rotation Lens");
  fl_addto_choice(obj, "Double Plane Model");  
  fl_addto_choice(obj, "Uniform Ring");  
  fl_addto_choice(obj, "Second Order");  
  fl_addto_choice(obj, "Elliptic SIS");  
  fl_addto_choice(obj, "Elliptic King");  
  fl_addto_choice(obj, "Elliptic Hubble");  
  fl_addto_choice(obj, "Elliptic NIS");  
  fl_addto_choice(obj, "Ellip. Plummer");  
  fl_addto_choice(obj, "Kassiola-Kovner");  
  fl_addto_choice(obj, "NFW");  
  fl_addto_choice(obj, "Barkana");  
  fl_set_choice(obj, 1);

  fdui->im_file = obj =
    fl_add_button(FL_NORMAL_BUTTON, 340, 190, 100, 35, "Image File");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, load_file, (long)(fdui)); 

  fdui->obip = obj =
    fl_add_button(FL_NORMAL_BUTTON, 340, 230, 100, 35, "OBIP");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_oposition, 0); 

  fdui->track = obj =
    fl_add_button(FL_NORMAL_BUTTON, 340, 270, 100, 35, "Track");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_track, 0); 
    
  fdui->sources = obj =
    fl_add_lightbutton(FL_PUSH_BUTTON, 450, 110, 100, 35, "Source");
  fl_set_object_color(obj, FL_YELLOW, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_SOURCE);

  fdui->images = obj =
    fl_add_lightbutton(FL_PUSH_BUTTON, 450, 150, 100, 35, "Images");
  fl_set_object_color(obj, FL_BLUE, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_IMAGES);

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 450, 190, 100, 35, "Smooth");
  fl_set_object_color(obj, FL_YELLOW, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_SMOOTH);

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 450, 230, 100, 35, "Grid");
  fl_set_object_color(obj, FL_YELLOW, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_GRID);

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 450, 270, 100, 35, "Ray Plot");
  fl_set_object_color(obj, FL_BLUE, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_RPLOT);

  /*

  fdui->choice2 = obj = fl_add_choice(FL_NORMAL_CHOICE, 560, 110, 100, 35, "");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_cc_caustic, (long)(fdui));
  fl_set_choice_entries(obj, fdchoice_2);
  fl_set_choice(obj, 1);

  **/
  
  fdui->caustic_critical = obj = 
    fl_add_button(FL_NORMAL_BUTTON, 560, 110, 100, 35, "CC / Caustic");
  fl_set_object_boxtype(obj, FL_UP_BOX); 
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_cc_caustic, (long)(fdui));
  
  /*
    
  fdui->root_pos = obj =
    fl_add_button(FL_NORMAL_BUTTON, 560, 150, 100, 35, "Roots");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_roots, (long)(fdui));

  **/

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 560, 150, 100, 35, "Roots");
  fl_set_object_color(obj, FL_BLUE, FL_YELLOW);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_root_positions, S_ROOTS);

  // fl_set_object_callback(obj, cb_switches, S_ROOTS);

  fdui->optimum = obj =
    fl_add_button(FL_NORMAL_BUTTON, 560, 190, 100, 35, "Fitting");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_optimum, (long)(fdui));

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 560, 230, 100, 35, "R_E");
  fl_set_object_color(obj, FL_YELLOW, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_EINSTEIN);

  obj = fl_add_lightbutton(FL_PUSH_BUTTON, 560, 270, 100, 35, "Contour");
  fl_set_object_color(obj, FL_BLUE, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_CONTOUR);

  fdui->help_win = obj =
    fl_add_button(FL_NORMAL_BUTTON, 670, 110, 100, 35, "Help");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_help, (long)(fdui));

  fdui->save = obj = fl_add_menu(FL_PUSH_MENU, 670, 150, 100, 35, "Save");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
  fl_set_menu_entries(obj, fdmenu_Save_2);
  fl_set_object_callback(obj, cb_save, 0); 

  obj = fl_add_button(FL_PUSH_BUTTON, 670, 190, 100, 35, "Inversion");
  fl_set_object_color(obj, FL_YELLOW, FL_BLUE);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_INVERT);   

  fdui->light_curve = obj =
    fl_add_button(FL_NORMAL_BUTTON, 670, 230, 100, 35, "Light Curve");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_light_curve, (long)(fdui));

  /*

  fdui->time_delay = obj =
    fl_add_button(FL_NORMAL_BUTTON, 670, 270, 100, 35, "Time Delay");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_time_delay, (long)(fdui));

  **/

  obj = fl_add_button(FL_PUSH_BUTTON, 670, 270, 100, 35, "Time Delay");
  fl_set_object_color(obj, FL_BLUE, FL_RED);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_TIMEDELAY);

  fdui->exit = obj = fl_add_button(FL_NORMAL_BUTTON, 780, 110, 80, 35, "Exit");
  fl_set_object_color(obj, FL_RED, FL_YELLOW);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_exit, 0);
  
  /******* Parameters *******/

  /*

  P_E,                1.5
  P_THETA,            0.0
  P_GAMMA,            0.05
  P_SIGMA,            0.05
  P_PHI,              0.0
  P_R,                0.1
  P_KAPPA,            1.0
  P_KAPPA2,           5.0
  P_EXP,              1.0
  P_C,                1.0
  P_XT,               1.0
  P_EPSILON,          0.4
  P_EPSILON2,         0.4
  P_ALPHA,            0.2
  P_ALPHA2,           1.0
  P_ALPHA3,           0.2
  P_KAPPA0,           1.0
  P_DX_QP,            0.5
  P_DY_QP,            0.5
  P_QXX,              0.1
  P_QXY,              0.0
  P_QYY,            - 0.1
  P_M_1,              0.5
  P_X_1,              0.0
  P_Y_1,              0.0
  P_BETA,             1.0
  P_GAMMA2,           0.05
  P_SIGMA2,           0.05
  P_PHI2,             0.0
  P_M_2,              0.5
  P_X_2,              0.0
  P_Y_2,              0.0
  P_SX,               0.5
  P_SY,               0.5
  P_Ri,               1.0
  P_Ro,               2.0
  P_Ko,               1.0
  P_Q3,               0.5
  P_Theta_INC         0.0

  **/

  /*
    
  fdui->model_ps = obj = 
    fl_add_button(FL_NORMAL_BUTTON, 20, 440, 840, 40, "Model Parameters");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, model_params, (long)(fdui));

  **/
   
  fdui->model_ps = obj = 
    fl_add_button(FL_NORMAL_BUTTON, 20, 330, 840, 40, "Model Parameters");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, model_params, (long)(fdui));

  fdui->p_E = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 20, 390, 40, 140, "E");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_E);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 1.5);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_theta = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 70, 390, 40, 140, "q"); 
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_THETA);
  fl_set_slider_bounds(obj, 360, 0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);    
 
  fdui->p_gamma = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 120, 390, 40, 140, "g");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_GAMMA);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 0.05);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_sigma = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 170, 390, 40, 140, "s");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_SIGMA);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 0.05);
  fl_set_slider_increment(obj, 0.01, 0.1);
   
  fdui->p_phi = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 220, 390, 40, 140, "f");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_PHI);
  fl_set_slider_bounds(obj, 360, 0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_R = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 270, 390, 40, 140, "R");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_R);
  fl_set_slider_bounds(obj, 2.0, 0.0);
  fl_set_slider_value(obj, 0.4);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_kappa = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "k");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_KAPPA);
  fl_set_slider_bounds(obj, 10.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
 
  fdui->p_kappa2 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "k2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_KAPPA2);
  fl_set_slider_bounds(obj, 15.0, 0.0);
  fl_set_slider_value(obj, 5.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_alpha2 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "a2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_ALPHA2);
  fl_set_slider_bounds(obj, 5.0, 0.001);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
    
  fdui->p_exp = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "b2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_EXP);
  fl_set_slider_bounds(obj, 1.90, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_C = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "C");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_C);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_xt = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "r_t");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_XT);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_ko = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "K");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_Ko);
  fl_set_slider_bounds(obj, 5.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_epsilon2 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "e2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_EPSILON2);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.4);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_epsilon3 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "e3");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_EPSILON3);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.4);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_alpha3 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 520, 390, 40, 140, "a");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_ALPHA3);
  fl_set_slider_bounds(obj, 2.0, - 1.0);
  fl_set_slider_value(obj, 0.2);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_uniform_ring = fl_bgn_group();
  fdui->p_rad_i = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "Ri");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_Ri);
  fl_set_slider_bounds(obj, 2.0, 0.001);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_rad_o = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "Ro");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_Ro);
  fl_set_slider_bounds(obj, 4, 0.001);
  fl_set_slider_value(obj, 2.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  fl_end_group();

  fdui->p_doublelens_model = fl_bgn_group();
  fdui->p_m_1 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "M1");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_M_1);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_x_1= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "X1");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_X_1);
  fl_set_slider_bounds(obj, 4.0, - 4.0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_y_1= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "Y1");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_Y_1);
  fl_set_slider_bounds(obj, 4.0, - 4.0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_beta = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 520, 390, 40, 140, "b");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_BETA);
  fl_set_slider_bounds(obj, 10.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_gamma2= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 570, 390, 40, 140, "g2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_GAMMA2);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.05);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_sigma2= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 620, 390, 40, 140, "s2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_SIGMA2);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.05);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_phi2 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 670, 390, 40, 140, "f2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_PHI2);
  fl_set_slider_bounds(obj, 360, 0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_m_2 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 720, 390, 40, 140, "M2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_M_2);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_x_2= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 770, 390, 40, 140, "X2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_X_2);
  fl_set_slider_bounds(obj, 4.0, - 4.0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_y_2= obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 820, 390, 40, 140, "Y2");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_Y_2);
  fl_set_slider_bounds(obj, 4.0, - 4.0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);
  fl_end_group();

  fdui->p_rotationlens_model = fl_bgn_group();
  fdui->p_sx = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "Sx");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_SX);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_sy = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "Sy");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_SY);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);
  fl_end_group();

  fdui->p_quadrupole_model = fl_bgn_group();
  fdui->p_kappa0 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 370, 390, 40, 140, "k0");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_KAPPA0);
  fl_set_slider_bounds(obj, 4.0, 0.0);
  fl_set_slider_value(obj, 1.0);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_dx_qp = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 390, 40, 140, "Dx");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_DX_QP);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_dy_qp = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "Dy");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_DY_QP);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.5);    
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_qxx = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 520, 390, 40, 140, "Qxx");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_QXX);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.1);        
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_qxy = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 570, 390, 40, 140, "Qxy");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_QXY);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, 0.0);        
  fl_set_slider_increment(obj, 0.01, 0.1);

  fdui->p_qyy = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 620, 390, 40, 140, "Qyy");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, cb_parameters, P_QYY);
  fl_set_slider_bounds(obj, 1.0, - 1.0);
  fl_set_slider_value(obj, - 0.1);        
  fl_set_slider_increment(obj, 0.01, 0.1);
  fl_end_group();

  fdui->p_elliptical_model = fl_bgn_group();
  fdui->p_epsilon = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470,390, 40, 140, "e");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_EPSILON);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.4);
  fl_set_slider_increment(obj, 0.01, 0.1);
  
  fdui->p_alpha = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 520, 390, 40, 140, "a");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_ALPHA);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.2);
  fl_set_slider_increment(obj, 0.01, 0.1);
  fl_end_group();


  fdui->p_elliptical_kk = fl_bgn_group();
  fdui->p_theta_inc = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 390, 40, 140, "qi");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 15);
  fl_set_object_callback(obj, cb_parameters, P_THETA_INC);
  fl_set_slider_bounds(obj, 360, 0);
  fl_set_slider_value(obj, 0.0);
  fl_set_slider_increment(obj, 0.01, 0.1);    

  fdui->p_q3 = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 520, 390, 40, 140, "q3");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_lstyle(obj, 0);
  fl_set_object_callback(obj, cb_parameters, P_Q3);
  fl_set_slider_bounds(obj, 1.0, 0.0);
  fl_set_slider_value(obj, 0.5);
  fl_set_slider_increment(obj, 0.01, 0.1);    
  fl_end_group();

  fl_end_form();

  fdui->GLcp->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_Oposition *create_form_Oposition(void)
{
  FL_OBJECT *obj;
  FD_Oposition *fdui = (FD_Oposition *) fl_calloc(1, sizeof(*fdui));
  
  fdui->O_position = fl_bgn_form(FL_NO_BOX, 520, 350);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 520, 350,"");

  obj = fl_add_button(FL_NORMAL_BUTTON, 410, 180, 90, 30, "Add");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_image_coordinates_add, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 410, 220, 90, 30, "Replace");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_image_coordinates_replace, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 410, 260, 90, 30, "Remove");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_image_coordinates_remove, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 410, 300, 90, 30, "Clear");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_image_coordinates_clear, (long)(fdui));

  fdui->imp_x = obj = fl_add_input(FL_FLOAT_INPUT, 50, 260, 130, 30, "X ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_imp, (long)(fdui));

  fdui->imp_y = obj = fl_add_input(FL_FLOAT_INPUT, 50, 300, 130, 30, "Y ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_imp, (long)(fdui));

  fdui->image_locations = obj = 
    fl_add_browser(FL_HOLD_BROWSER, 230, 140, 140, 190, "Images");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_TOP);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, cb_imp, (long)(fdui));

  obj = fl_add_text(FL_NORMAL_TEXT, 20, 20, 480, 60,
		    "Input of Observed Image Positions");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_LARGE_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_EMBOSSED_STYLE);
  
  fdui->ex_op = obj =
    fl_add_button(FL_NORMAL_BUTTON, 410, 100, 90, 30, "Exit");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, exit_op, 0);

  obj = fl_add_button(FL_PUSH_BUTTON, 410, 140, 90, 30, "Draw");  
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_switches, S_OBIP); 

  fdui->inp_noim = obj =
    fl_add_input(FL_FLOAT_INPUT, 50, 140, 130, 30, "Number of Images");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_TOP);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);

  obj = fl_add_button(FL_NORMAL_BUTTON, 50, 200, 60, 30, "Set");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_impset, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 120, 200, 60, 30,"Reset");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, cb_impreset, (long)(fdui));  
  fl_end_form();

  fdui->O_position->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_Optimum *create_form_Optimum(void)
{
  FL_OBJECT *obj;
  FD_Optimum *fdui = (FD_Optimum *) fl_calloc(1, sizeof(*fdui));

  fdui->Optimum = fl_bgn_form(FL_NO_BOX, 320, 410);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 320, 410,"");

  fdui->wg_a = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 210, 170, 40, 200, "W_A");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 1, 0);
  fl_set_slider_value(obj, 0);

  fdui->wg_p = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER, 260, 170, 40, 200, "W_P");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 1, 0);
  fl_set_slider_value(obj, 1);

  fdui->inp_nop = obj =
    fl_add_input(FL_NORMAL_INPUT, 30, 110, 130, 40,"Number of parametres");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_TOP);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, number_var_opt, 0);

  obj = fl_add_box(FL_UP_BOX, 20, 20, 280, 50, "Model Optimization");
  fl_set_object_lsize(obj, FL_LARGE_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);

  obj = fl_add_button(FL_NORMAL_BUTTON, 30, 330, 130, 40, "Exit");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, ex_opt, 0);

  obj = fl_add_labelbutton(FL_NORMAL_BUTTON, 210, 120, 90, 40, "Weights");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);

  obj = fl_add_button(FL_NORMAL_BUTTON, 30, 280, 130, 40, "Optimize");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, optim_of_models, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 30, 230, 60, 40,"Set");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, set_opt, (long)(fdui));

  obj = fl_add_button(FL_NORMAL_BUTTON, 100, 230, 60, 40,"Reset");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, reset_opt, (long)(fdui));

  /* 

  fdui->dist_max = obj =
    fl_add_input(FL_NORMAL_INPUT, 70, 230, 90, 40,"D_MAX ");
  fl_set_object_lsize(obj,FL_SMALL_SIZE); 

  **/

  /*

  fdui->n_consts = obj =
    fl_add_input(FL_NORMAL_INPUT, 30, 180, 130, 40,"Number of constraints");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_TOP);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);

  **/

  fdui->opt_method = obj = 
    fl_add_menu(FL_PUSH_MENU, 30, 180, 130, 40, "Opt. Method");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
  fl_set_menu_entries(obj, fdmenu_Save_3);
  fl_set_object_callback(obj, cb_method, 0); 
  
  fl_end_form();
  
  fdui->Optimum->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_Parametres *create_form_Parametres(void)
{
  FL_OBJECT *obj;
  FD_Parametres *fdui = (FD_Parametres *) fl_calloc(1, sizeof(*fdui));

  fdui->Parameters = fl_bgn_form(FL_NO_BOX, 1020, 720);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 1020, 720, "");

  obj = fl_add_box(FL_UP_BOX, 20, 20, 980, 70, "Model Parameters");
  fl_set_object_lsize(obj, FL_LARGE_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);

  fdui->input_x = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 200, 150, 40, "X  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_y = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 250, 150, 40, "Y  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_E = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 300, 150, 40, "E  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_theta = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 350, 150, 40, "q  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_gamma = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 400, 150, 40, "g  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_sigma = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 450, 150, 40, "s  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_phi = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 500, 150, 40, "f  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_kappa = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 550, 150, 40, "k  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_epsilon = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 600, 150, 40, "e  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_C = obj =
    fl_add_input(FL_NORMAL_INPUT, 50, 650, 150, 40, "C  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_x1 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 200, 150, 40, "X1  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_y1 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300,250, 150, 40, "Y1  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_x2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300,300, 150, 40, "X2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_y2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300,350, 150, 40, "Y2  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_m1 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 400, 150, 40, "M1 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_m2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 450, 150, 40, "M2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_beta = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 500, 150, 40, "b  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_gamma2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 550, 150, 40, "g2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_sigma2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 600, 150, 40, "s2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_phi2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 300, 650, 150, 40, "f2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_sx = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 200, 150, 40, "Sx ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_sy = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 250, 150, 40, "Sy ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_alpha = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 300, 150, 40, "a  ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_alpha2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 350, 150, 40, "a2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_alpha3 = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 400, 150, 40, "a3 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);    

  fdui->input_exp = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 450, 150, 40, "b2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);    

  fdui->input_kappa2 = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 500, 150, 40, "k2 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_ri = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 550, 150, 40, "Ri ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_ro = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 600,  150, 40, "Ro");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_ko = obj =
    fl_add_input(FL_NORMAL_INPUT, 550, 650,  150, 40, "K ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  
  fdui->input_kappa0 = obj =
    fl_add_input(FL_NORMAL_INPUT,800, 200, 150, 40, "k0 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);
  
  fdui->input_dx = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 250, 150, 40, "Dx");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_dy = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 300, 150, 40, "Dy");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_qxx = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 350, 150, 40, "Qxx");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_qxy = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 400, 150, 40, "Qxy");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_qyy = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 450, 150, 40, "Qyy");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_thetai = obj =
    fl_add_input(FL_NORMAL_INPUT,800, 500, 150, 40, "qi ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_q3 = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 550, 150, 40, "q3 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);

  fdui->input_epsilon2 = obj =
    fl_add_input(FL_NORMAL_INPUT,800, 600, 150, 40, "e2");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  fdui->input_epsilon3 = obj =
    fl_add_input(FL_NORMAL_INPUT, 800, 650, 150, 40, "e3 ");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, 15);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 120, 40, 40, "Macro");
  fl_set_object_callback(obj, cb_macro_opt, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 310, 120, 40, 40, "Scale E");
  fl_set_object_callback(obj, cb_scale_opt, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 410, 120, 40, 40,"Model");
  fl_set_object_callback(obj, cb_model_opt, 0);


  /* First ten buttons */
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 200, 40, 40, "");
  fl_set_object_callback(obj, cb_sa1, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 210, 250, 40, 40, "");
  fl_set_object_callback(obj, cb_sa2, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 300, 40, 40,"");
  fl_set_object_callback(obj, cb_sa3, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 210, 350, 40, 40, "");
  fl_set_object_callback(obj, cb_sa4, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 400, 40, 40, "");
  fl_set_object_callback(obj, cb_sa5, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 210, 450, 40, 40, "");
  fl_set_object_callback(obj, cb_sa6, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 500, 40, 40, "");
  fl_set_object_callback(obj, cb_sa7, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 210, 550, 40, 40, "");
  fl_set_object_callback(obj, cb_sa8, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 210, 600, 40, 40, "");
  fl_set_object_callback(obj, cb_sa9, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 210, 650, 40, 40, "");
  fl_set_object_callback(obj, cb_sa10, 0);

  /* Second ten buttons */

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 460, 200, 40, 40, "");
  fl_set_object_callback(obj, cb_sa11, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 460, 250, 40, 40, "");
  fl_set_object_callback(obj, cb_sa12, 0);
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 460, 300, 40, 40, "");
  fl_set_object_callback(obj, cb_sa13, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 460, 350, 40, 40, "");
  fl_set_object_callback(obj, cb_sa14, 0);
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 460, 400, 40, 40, "");
  fl_set_object_callback(obj, cb_sa15, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 460, 450, 40, 40, "");
  fl_set_object_callback(obj, cb_sa16, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 460, 500, 40, 40, "");
  fl_set_object_callback(obj, cb_sa17, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 460, 550, 40, 40, "");
  fl_set_object_callback(obj, cb_sa18, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 460, 600, 40, 40, "");
  fl_set_object_callback(obj, cb_sa19, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 460, 650, 40, 40, "");
  fl_set_object_callback(obj, cb_sa20, 0);

  /* Third ten buttons */
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 710, 200, 40, 40, "");  
  fl_set_object_callback(obj, cb_sa21, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 710, 250, 40, 40, "");
  fl_set_object_callback(obj, cb_sa22, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 710, 300, 40, 40, "");
  fl_set_object_callback(obj, cb_sa23, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 710, 350, 40, 40, "");
  fl_set_object_callback(obj, cb_sa24, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 710, 400, 40, 40, "");
  fl_set_object_callback(obj, cb_sa25, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 710, 450, 40, 40, "");
  fl_set_object_callback(obj, cb_sa26, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON,710, 500, 40, 40, "");
  fl_set_object_callback(obj, cb_sa27, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 710, 550, 40, 40, "");
  fl_set_object_callback(obj, cb_sa28, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON,710, 600, 40, 40, "");
  fl_set_object_callback(obj, cb_sa29, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 710, 650, 40, 40, "");
  fl_set_object_callback(obj, cb_sa30, 0);

  /* Fourth ten buttons */

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 960, 200, 40, 40, "");
  fl_set_object_callback(obj, cb_sa31, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 960, 250, 40, 40, "");
  fl_set_object_callback(obj, cb_sa32, 0);
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 960, 300, 40, 40, "");
  fl_set_object_callback(obj, cb_sa33, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 960, 350, 40, 40, "");
  fl_set_object_callback(obj, cb_sa34, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 960, 400, 40, 40, "");
  fl_set_object_callback(obj, cb_sa35, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 960, 450, 40, 40, "");
  fl_set_object_callback(obj, cb_sa36, 0);
  
  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 960, 500, 40, 40, "");
  fl_set_object_callback(obj, cb_sa37, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 960, 550, 40, 40, "");
  fl_set_object_callback(obj, cb_sa38, 0);

  obj = fl_add_checkbutton(FL_PUSH_BUTTON, 960, 600, 40, 40, "");
  fl_set_object_callback(obj, cb_sa39, 0);

  obj = fl_add_round3dbutton(FL_PUSH_BUTTON, 960, 650, 40, 40, "");
  fl_set_object_callback(obj, cb_sa40, 0);

  // obj = fl_add_button(FL_NORMAL_BUTTON, 610, 120, 70, 30, "CC & C");

  fdui->cc_caustics = obj = 
    fl_add_menu(FL_PUSH_MENU, 610, 120, 70, 30, "CC & C"); 
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
  fl_set_menu_entries(obj, fdmenu_caustic);
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, caustic_old, 0);

  obj = fl_add_button(FL_NORMAL_BUTTON, 690, 120, 70, 30, "Fit");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, fit_par, 0);

  obj = fl_add_button(FL_NORMAL_BUTTON, 770, 120, 70, 30, "Set");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, set_par, 0);

  obj = fl_add_button(FL_NORMAL_BUTTON, 850, 120, 70, 30, "Reset");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, reset_par, 0);

  fdui->ex_params = obj =
    fl_add_button(FL_NORMAL_BUTTON, 930, 120, 70, 30, "Exit");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_callback(obj, ex_par, 0);
    
  fl_end_form();

  fdui->Parameters->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_track *create_form_track(void)
{
  FL_OBJECT *obj;
  FD_track *fdui = (FD_track *) fl_calloc(1, sizeof(*fdui));

  fdui->tracks = fl_bgn_form(FL_NO_BOX, 240, 460);
  obj = fl_add_box(FL_UP_BOX,0,0,240,460,"");

  fdui->AX = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER,20,220,40,200,"Ax");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 4, -4);
  fl_set_slider_value(obj, 0);

  fdui->AY = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER,70,220,40,200,"Ay");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 4, -4);
  fl_set_slider_value(obj, 0);

  fdui->BX = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER,130,220,40,200,"Bx");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 4, -4);
  fl_set_slider_value(obj, 0);

  fdui->BY = obj =
    fl_add_valslider(FL_VERT_BROWSER_SLIDER,180,220,40,200,"By");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_slider_bounds(obj, 4, -4);
  fl_set_slider_value(obj, 0);

  obj = fl_add_button(FL_NORMAL_BUTTON,20,100,90,40,"Animate");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_object_callback(obj, anim_track, 0);

  obj = fl_add_button(FL_NORMAL_BUTTON,130,100,90,40,"Done");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_object_callback(obj, done_track, 0);
  
  obj = fl_add_box(FL_UP_BOX,20,20,200,60,"Animation Track");
  fl_set_object_lsize(obj,FL_LARGE_SIZE);
  fl_set_object_lstyle(obj,FL_NORMAL_STYLE + FL_ENGRAVED_STYLE);

  obj = fl_add_button(FL_NORMAL_TEXT,20,170,90,40,"Initial Point");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_object_callback(obj, set_inpt, 0);
 
  obj = fl_add_button(FL_NORMAL_TEXT,130,170,90,40,"Final Point");
  fl_set_object_lsize(obj,FL_SMALL_SIZE);
  fl_set_object_callback(obj, set_fipt, 0);
  
  fl_end_form();

  fdui->tracks->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_Help *create_form_Help(void)
{
  FL_OBJECT *obj;
  FD_Help *fdui = (FD_Help *) fl_calloc(1, sizeof(*fdui));
  
  fdui->Help_me = fl_bgn_form(FL_NO_BOX, 575, 675);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 575, 675, "");

  obj = fl_add_browser(FL_NORMAL_BROWSER, 40, 100, 490, 490, "");
  fl_set_object_color(obj, FL_WHITE, FL_YELLOW);
  fl_set_browser_vscrollbar(obj, FL_ON);
  
  fl_add_browser_line(obj, " ");      
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C5@l@b@c Gravitational Lens Visualization"
                      " Project ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C5@l@b@c by ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C5@l@b@c Francisco Frutos-Alfaro ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The mouse allows you to change all"
                      " parameters, buttons, etc. which are listed here.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M First of all choose a model and a source by"
                      " clicking the Menu Model and the Source Menu"
                      " buttons.");
  fl_add_browser_line(obj, " ");
  
  fl_add_browser_line(obj,"@M Click the Image Window button to see the"
                      " images, etc. on this window on-line.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Model Menu");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This menu contain the following models:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Chang Refsdal Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Singular Isothermal Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Nosingular Isothermal Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Transparent Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Elliptical Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M King Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Truncated King Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Hubble Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M De Vaucouleur Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Spiral Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Mutilpole Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Rotation Lens");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Double Point Mass");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Uniform Ring.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Model Parameters");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M By clicking this button all sliders"
                      " disappear.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M For the models there are some lens"
                      " parameter:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M E: Einstein radius or length scale");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Theta: Rotation angle of the coordinates");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Sigma: The surface mass density of macrolens"
                      " at the location of");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M the microlens or chosen model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Gamma: The shear of the macrolens at the"
                      " location of the microlens");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M or chosen model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Phi: The shear angle");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M R: The source radius.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Chang Refsdal Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Elliptical Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M C: Core radius");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Epsilon: Ellipticity");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Alpha: Softness");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Central surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b King Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Central surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Truncated King Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M C: Truncation or Tidal Radius");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Central surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b De Vaucouleur Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Surface mass density at the Effective"
                      " Radius.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Hubble Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Central surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Spiral Model");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Double Plane Lens");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M M1: Mass of the first Lens on the"
                      " first plane");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M M2: Mass of the second Lens on the"
                      " second plane");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Beta: Distance between both Lens planes");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M (x1, y1): Position of the first Lens"
                      " on the first plane");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M (x2, y2): Position of the second Lens"
                      " on the second plane.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Singular Isothermal Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and one additional slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Mass exponent.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Nonsingular Isothermal Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and one additional slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M C: Core radius");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Kappa: Central surface mass density.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Transparent Sphere");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and one additional slider:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M C: Sphere radius.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Multipole Lens");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M (dx, dy): Dipole components");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M (q1, q2): Quadrupole components"
                      " q11 and q12, with q11 + q22 = 0");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M and q12 = q21.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Rotation Lens");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M This model uses the afore mentioned"
                      " sliders and the following sliders:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M (Sx, Sy): Rotation components of the"
                      " point mass.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Image Window");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The Image Window appears by clicking this"
                      " button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The images of the chosen model will appear"
                      " when you have chosen a model.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Source Menu");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Choice between the following figures:");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Filled Circle");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Coloured Circles");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Image File.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The default image figure is m45.jpg."
                      " To choose other figure click the File button."); 
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The program could crash if the figure"
                      " m45.jpg is not in the current directory.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Source Position");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");  
  fl_add_browser_line(obj, "@M To place the source use the cross"
                      " hair mouse on the field of this positioner.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To get a fine position click the"
                      " counters X and Y.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Counter Resolution: N");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To control the pixel resolution.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Input Fields X and Y");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To place a circles that represent the"
                      " observed images of a Gravitational Lens.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M If you want to add an image position click"
                      " the Add button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To replace an image position mark the"
                      " position on the browser and click the"
                      " Replace button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M If you want to remove an image position mark"
                      " the position on the browser and click"
                      " the Remove button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To clear all the image positions click the"
                      " Clear button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M All image positions will appear in the"
                      " Images browser");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To shown these image positions click the"
                      " OBIP button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Source");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To obtain the source position click this"
                      " button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Images");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Click this buttom to get the image"
                      " positions.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Smooth");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To smooth the images and the source.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Grid");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To get a grid on the image window click"
                      " this button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b R Plot");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M In order to get a Ray Plot of the"
                      " chosen lens model.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Save");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M To save the image window with your results"
                      " click this button.");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M The public domain program `gimp' "
                      "appears if it exists in your computer.");
  fl_add_browser_line(obj, " ");  
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@C1@l@b Exit");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, " ");
  fl_add_browser_line(obj, "@M Bye, bye!");
  fl_add_browser_line(obj, " ");  
  fl_add_browser_line(obj, " "); 

  obj = fl_add_text(FL_NORMAL_TEXT, 40, 20, 490, 60,
		    "Visualization of Gravitational Lenses");
  fl_set_object_boxtype(obj, FL_UP_BOX);
  fl_set_object_lsize(obj, FL_LARGE_SIZE);
  fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE + FL_EMBOSSED_STYLE);

  fdui->exit_h = obj =
    fl_add_button(FL_NORMAL_BUTTON, 420, 610, 110, 40, "Exit");
  fl_set_object_lsize(obj, FL_SMALL_SIZE);
  fl_set_object_lstyle(obj, FL_NORMAL_STYLE);
  fl_set_object_callback(obj, exit_help, 0);
  fl_end_form();
  
  fdui->Help_me->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/

FD_caustics *create_form_caustics(void)
{
  FL_OBJECT *obj;
  FD_caustics *fdui = (FD_caustics *) fl_calloc(1, sizeof(*fdui));

  fdui->caustics = fl_bgn_form(FL_NO_BOX, 320, 400);
  obj = fl_add_box(FL_UP_BOX, 0, 0, 330, 400, "");
  obj = fl_add_box(FL_UP_BOX, 20, 20, 280, 50, "Critical Curves and Caustics");
  fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
  fl_set_object_lstyle(obj, FL_BOLD_STYLE+FL_EMBOSSED_STYLE);
  fdui->c_dx = obj = 
    fl_add_input(FL_NORMAL_INPUT, 70, 90, 170, 40, "DX");
  fl_set_object_callback(obj, cc_dx, 0);
  fdui->c_tol =
    obj = fl_add_input(FL_NORMAL_INPUT, 70, 140, 170, 40, "TOL");
  fl_set_object_callback(obj, cc_tol, 0);
  fdui->c_set = obj = 
    fl_add_button(FL_NORMAL_BUTTON, 70, 190, 170, 40, "Set Input");
  fl_set_object_lsize(obj,FL_NORMAL_SIZE);
  fl_set_object_callback(obj, c_set_input, 0);
  fdui->critic_c = obj = 
    fl_add_lightbutton(FL_PUSH_BUTTON, 70, 240, 170, 40, "Critical Curves");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, critic_curve, 0);
  fdui->caustic_c = obj = 
    fl_add_lightbutton(FL_PUSH_BUTTON, 70, 290, 170, 40, "Caustics");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, caustic_curve, 0);
  fdui->done_c = obj = 
    fl_add_button(FL_NORMAL_BUTTON, 70, 340, 170, 40, "Done");
  fl_set_object_lsize(obj, FL_NORMAL_SIZE);
  fl_set_object_callback(obj, caustic_done, 0);
  fl_end_form();

  fdui->caustics->fdui = fdui;

  return fdui;
}

/*---------------------------------------*/










