/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "caustical.h"

FD_caustics *create_form_caustics(void)
{
  FL_OBJECT *obj;
  FD_caustics *fdui = (FD_caustics *) fl_calloc(1, sizeof(*fdui));

  fdui->caustics = fl_bgn_form(FL_NO_BOX, 330, 400);
  obj = fl_add_box(FL_UP_BOX,0,0,330,400,"");
  obj = fl_add_box(FL_UP_BOX,20,20,280,50,"Critical Curves and Caustics");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE+FL_EMBOSSED_STYLE);
  fdui->c_dx = obj = fl_add_input(FL_NORMAL_INPUT,70,90,170,40,"DX");
    fl_set_object_callback(obj,cc_dx,0);
  fdui->c_tol = obj = fl_add_input(FL_NORMAL_INPUT,70,140,170,40,"TOL");
    fl_set_object_callback(obj,cc_tol,0);
  fdui->done_c = obj = fl_add_button(FL_NORMAL_BUTTON,70,340,170,40,"Done");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_callback(obj,caustic_done,0);
  fdui->critic_c = obj = fl_add_lightbutton(FL_PUSH_BUTTON,70,240,170,40,"Critical Curves");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_callback(obj,critic_curve,0);
  fdui->caustic_c = obj = fl_add_lightbutton(FL_PUSH_BUTTON,70,290,170,40,"Caustics");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_callback(obj,caustic_curve,0);
  fdui->c_set = obj = fl_add_button(FL_NORMAL_BUTTON,70,190,170,40,"Set Input");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_callback(obj,c_set_input,0);
  fl_end_form();

  fdui->caustics->fdui = fdui;

  return fdui;
}
/*---------------------------------------*/

