/*
 * Example program by pipas@linux.pte.hu
 *
 * This program is uninterruptable  with Ctrl+C, uses signal handler
 *
 * http://www.metalshell.com/
 *
 */

#include <stdio.h>
#include <signal.h>
#include <unistd.h>

#define FALSE 0
#define TRUE  1

/* The signal handler function */

void handler(int signal) 
{
  printf("Signal handler...\n");
  psignal(signal, "Signal: ");
}  /*handler*/

int main() 
{
  /* Registering the handler, catching SIGINT signals */
  
  signal( SIGINT, handler );

  /* Do nothing */
  
  while(TRUE) {
    printf("Running...\n");
    sleep(10);
  } /*while*/

  return(0);
} /*main*/
